SystemOrganization addCategory: #'ICU-V2-System'!

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 07:47'!
asExternalFunctionParameter 

	^self uCodePoint ! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:20'!
uCharDigitValue
"^<Integer>

	Returns the decimal digit value of a decimal digit character.
	Such characters have the general category 'Nd' (decimal digit numbers) and a Numeric_Type of Decimal.
	Unlike ICU releases before 2.6, no digit values are returned for any Han characters because 
	Han number characters are often used with a special Chinese-style number format (with characters 
	for powers of 10 in between) instead of in decimal-positional notation. Unicode 4 explicitly assigns 
	Han number characters the Numeric_Type Numeric instead of Decimal. See Jitterbug 1483 for more details.
"

	^ICULibrary interfaceClass uCharDigitValue: self! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:47'!
uCharName: choice
	"^<ByteString> Retrieve the name of a Unicode character.

			$A uCharName: 0
	
	
	"
	^ICULibrary interfaceClass uCharName: self nameChoice: choice! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 07:43'!
uCodePoint

	^self codePoint ! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:29'!
uDigitForRadix: radix
"^<Integer>
	Returns the decimal digit value of the code point in the specified radix.

If the radix is not in the range 2<=radix<=36 or if the value of c is not a valid digit in the specified radix, -1 is returned. A character is a valid digit if at least one of the following is true:

    The character has a decimal digit value. Such characters have the general category 'Nd' (decimal digit numbers) and a Numeric_Type of Decimal. In this case the value is the character's decimal digit value.
    The character is one of the uppercase Latin letters 'A' through 'Z'. In this case the value is c-'A'+10.
    The character is one of the lowercase Latin letters 'a' through 'z'. In this case the value is ch-'a'+10.
    Latin letters from both the ASCII range (0061..007A, 0041..005A) as well as from the Fullwidth ASCII range (FF41..FF5A, FF21..FF3A) are recognized.

"
	^ICULibrary interfaceClass uDigit: self radix: radix! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:22'!
uIsAlNum
	"^<Boolean> 
	
		Determines whether the specified code point is an alphanumeric character (letter or digit) according to Java.
		True for characters with general categories ''L'' (letters) and 'Nd' (decimal digit numbers).
	"

	^ICULibrary interfaceClass uIsAlNum: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:22'!
uIsAlpha
	"^<Boolean> 
	
	Determines whether the specified code point is a letter character.
	True for general categories 'L' (letters).
	"

	^ICULibrary interfaceClass uIsAlpha: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:23'!
uIsAlphabetic
	"^<Boolean> 
	
		Check if a code point has the Alphabetic Unicode property.
		Same as u_hasBinaryProperty(c, UCHAR_ALPHABETIC). This is different from u_isalpha!! 
	"

	^ICULibrary interfaceClass uIsAlphabetic: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsBase
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsBase: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:02'!
uIsBlank
	"^<Boolean> 
	
		$1 uIsBlank
	"

	^ICULibrary interfaceClass uIsBlank:  self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsCntrl
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsCntrl: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsDefined
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsDefined: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsDigit
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsDigit: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsGraph
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsGraph: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsISOCntrl
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsISOCntrl: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsJavaSpaceChar
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsJavaSpaceChar: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:26'!
uIsLower
	"^<Boolean> 
The given character is mapped to its lowercase equivalent according to UnicodeData.txt; if the character has no lowercase equivalent, the character itself is returned.

Same as java.lang.Character.toLowerCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class.	
	"

	^ICULibrary interfaceClass uIsLower: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:23'!
uIsLowercase
	"^<Boolean> 

		Check if a code point has the Lowercase Unicode property.
		Same as u_hasBinaryProperty(c, UCHAR_LOWERCASE). This is different from u_islower!! 	
	"

	^ICULibrary interfaceClass uIsLowercase: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:03'!
uIsPrint
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsPrint: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:04'!
uIsPunct
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsPunct: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:04'!
uIsSpace
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsSpace: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:04'!
uIsTitle
	"^<Boolean> 
	
	"

	^ICULibrary interfaceClass uIsTitle: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:24'!
uIsUpper
	"^<Boolean> 

		Determines whether the specified code point has the general category  'Lu' (uppercase letter).

		This misses some characters that are also uppercase but have a different general category value. In 	
		order to include those, use UCHAR_UPPERCASE.	
	"

	^ICULibrary interfaceClass uIsUpper: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:24'!
uIsUppercase
	"^<Boolean> 
		Check if a code point has the Uppercase Unicode property.
		Same as u_hasBinaryProperty(c, UCHAR_UPPERCASE). This is different from u_isupper!! 	
	"

	^ICULibrary interfaceClass uIsUppercase: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:25'!
uIsWhitespace
	"^<Boolean> 
Determines if the specified code point is a whitespace character according to Java/ICU.

A character is considered to be a Java whitespace character if and only if it satisfies one of the following criteria:

    It is a Unicode Separator character (categories 'Z' = 'Zs' or 'Zl' or 'Zp'), but is not also a non-breaking space (U+00A0 NBSP or U+2007 Figure Space or U+202F Narrow NBSP).
    It is U+0009 HORIZONTAL TABULATION.
    It is U+000A LINE FEED.
    It is U+000B VERTICAL TABULATION.
    It is U+000C FORM FEED.
    It is U+000D CARRIAGE RETURN.
    It is U+001C FILE SEPARATOR.
    It is U+001D GROUP SEPARATOR.
    It is U+001E RECORD SEPARATOR.
    It is U+001F UNIT SEPARATOR.

This API tries to sync with the semantics of Java's java.lang.Character.isWhitespace(), but it may not return the exact same results because of the Unicode version difference.

Note: Unicode 4.0.1 changed U+200B ZERO WIDTH SPACE from a Space Separator (Zs) to a Format Control (Cf). Since then, isWhitespace(0x200b) returns false. See http://www.unicode.org/versions/Unicode4.0.1/	
	"

	^ICULibrary interfaceClass uIsWhitespace: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:26'!
uIsXDigit
	"^<Boolean> 
	Determines whether the specified code point is a hexadecimal digit.

This is equivalent to u_digit(c, 16)>=0. True for characters with general category 'Nd' (decimal digit numbers) as well as Latin letters a-f and A-F in both ASCII and Fullwidth ASCII. (That is, for letters with code points 0041..0046, 0061..0066, FF21..FF26, FF41..FF46.)

In order to narrow the definition of hexadecimal digits to only ASCII characters, use (c<=0x7f && u_isxdigit(c)).	
	"

	^ICULibrary interfaceClass uIsXDigit: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:27'!
uToLower
	"^<Character> 
	The given character is mapped to its lowercase equivalent according to UnicodeData.txt; if the character has no lowercase equivalent, the character itself is returned.

Same as java.lang.Character.toLowerCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class. 
	"

	^ICULibrary interfaceClass uToLower: self 
	! !

!Character methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 10:27'!
uToUpper
	"^<Character> 
	
The given character is mapped to its uppercase equivalent according to UnicodeData.txt; if the character has no uppercase equivalent, the character itself is returned.

Same as java.lang.Character.toUpperCase().

This function only returns the simple, single-code point case mapping. Full case mappings should be used whenever possible because they produce better results by working on whole strings. They take into account the string context and the language and can map to a result string with a different length as appropriate. Full case mappings are applied by the string case mapping functions, see ustring.h and the UnicodeString class	"

	^ICULibrary interfaceClass uToUpper: self 
	! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:17'!
asUCalendar
	"^<UCalendar> Returns an instance of UCalendar
		Example: 	Date today asUCalendar	
	"

	"offset in ICU and DateAndTime are different !!"

	^(UCalendar
		openDefaultWithLocale: nil
		timezone: UCalendar getDefaultTimeZone )
						fromDate: self;
						yourself
! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:17'!
uDayOfWeekAbbreviation

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uDayOfWeekAbbreviation.
	meAsUCalendar close.
	^result! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:17'!
uDayOfWeekName

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uDayOfWeekName.
	meAsUCalendar close.
	^result! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:17'!
uMonthAbbreviation

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uMonthAbbreviation.
	meAsUCalendar close.
	^result! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:17'!
uMonthName

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uMonthName.
	meAsUCalendar close.
	^result! !

!Date methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:18'!
uPrintString

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uPrintString.
	meAsUCalendar close.
	^result! !

!Duration methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/10/2012 11:06'!
subtractFromUCalendar: anUCalendar
	"^<Duration>
	
		| now nowPlusTwo |
		
		now := UCalendar now.
		nowPlusTwo := now clone + (Duration hours: 2).
		(nowPlusTwo - now) inspect
	
	
	"

	^anUCalendar clone addMilliseconds: (0 - self asMilliSeconds )! !

SortedCollection subclass: #USortedCollection
	instanceVariableNames: 'uLocale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!USortedCollection class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/9/2012 22:25'!
sortBlock: aBlock

	^self
		sortBlock: aBlock
		in: ICUSystemLocale current! !

!USortedCollection class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/9/2012 22:26'!
sortBlock: aBlock in: anULocale

	| newInstance |

	newInstance := super sortBlock: aBlock.
	newInstance uLocale: anULocale.

	^newInstance! !

!USortedCollection methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:25'!
uLocale
	^ uLocale! !

!USortedCollection methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:25'!
uLocale: anObject
	uLocale := anObject! !

OSVoid subclass: #ICUGeneralObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/3/2012 22:17'!
allCountryTimeZonesFor: countryString
	"^<OrderedCollections of: String> Returns a collection of locales suitable for specific country. Result collection has SB-strings
	
		Example:  UCalendar allCountryTimeZonesFor: nil	
	"

	| enumerator results |

	enumerator := self openCountryTimeZonesFor: countryString.
	results := enumerator collectAll.
	enumerator close.
	^results

! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/3/2012 22:01'!
allTimeZones
	"^<OrderedCollections of: String> Returns a collection with all known time zones - instances of SB strings
	
		Example: UCalendar allTimeZones
		
	"

	| enumerator results |

	enumerator := self openTimeZones.
	results := enumerator collectAll.
	enumerator close.
	^results
! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/3/2012 22:25'!
availableLocales
	"^<OrderedCollection of: String> Get all known locales for which calendars are available. 
	
		UCalendar availableLocales
	"

	| sortedCollection |

	sortedCollection := SortedCollection new.
	0 to: self countAvailableLocales - 1 do: [ :anIndex |
		sortedCollection add:  (self getAvailableLocaleIndexed: anIndex) ].
	
	^sortedCollection asOrderedCollection! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/5/2012 20:54'!
clockPrecision

	^DateAndTime clockPrecision! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:45'!
countAvailableLocales
	"^<Integer> Determine how many locales have calendars available. "

	^ICUInterfaceClass uCalCountAvailable 
! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/6/2012 11:54'!
dbAllCountryTimeZonesFor: countryString
	"^<OrderedCollections of: DBString> UCalendar dbAllCountryTimeZonesFor: 'GB'
	
	"

	| enumerator result |

	enumerator := self openCountryTimeZonesFor: countryString.
	result := enumerator dbCollect: [ :each | each ].
	enumerator close.
	^result! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:46'!
getAvailableLocaleIndexed: zeroBasedIndex

	^ICUInterfaceClass uCalGetAvailableAt: zeroBasedIndex! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:46'!
getDSTSavings: zoneIDUChar
	"^<Integer> Return the amount of time in milliseconds that the clock is advanced during daylight savings time for the given time zone, or zero if the time zone does not observe daylight savings time
	
		UCalendar getDSTSavings: UCalendar	icuDefaultTimeZone
	
	"
	
	^ICUInterfaceClass uCalGetDSTSavings: zoneIDUChar ! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/11/2012 23:23'!
getDefaultTimeZone
	"^<DBString> Return the default time zone - this time I use the countryAbbreviation to get the correct time zone

		UCalendar getDefaultTimeZone
	
	"

	| icuDefaultTimeZone timeZonesFormyCountry icuDefaultTimeZoneCalendar timeZoneFound |

	icuDefaultTimeZone := self icuDefaultTimeZone.
	timeZonesFormyCountry := self allCountryTimeZonesFor: ULocale defaultLocaleName icuCountryCode.
	timeZonesFormyCountry isEmpty
		ifTrue: [ ^icuDefaultTimeZone ].

	icuDefaultTimeZoneCalendar := UCalendar openDefaultWithLocale: ULocale defaultLocaleName timezone: self icuDefaultTimeZone.
	
	timeZonesFormyCountry do: [ :eachCountryAbbreviation |
		| myCountryCalendar |
		
		myCountryCalendar := UCalendar openDefaultWithLocale: ULocale defaultLocaleName timezone: eachCountryAbbreviation.
		(myCountryCalendar offset = icuDefaultTimeZoneCalendar offset)
			ifTrue: [ timeZoneFound := eachCountryAbbreviation ].
		myCountryCalendar close.	
	].

	icuDefaultTimeZoneCalendar close.
	^timeZoneFound ifNil: [ icuDefaultTimeZone ]


! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:46'!
icuDefaultTimeZone
	"^<Utf16String>  Return the default time zone. The default is determined initially by querying the host operating system.

		UCalendar icuDefaultTimeZone
	"
	^ICUInterfaceClass uCalGetDefaultTimeZone! !

!UCalendar class methodsFor: 'services' stamp: 'MartenFeldtmann 9/7/2012 10:16'!
millisOfNow
	"^<Double> Returns the mullis value of the current date/time"
	
	| aCal millisVal |
	
	aCal := ICUSystemLocale current calendarNowCloned.
	millisVal := aCal millis.
	aCal close.
	^millisVal! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:36'!
new
	"^<UCalendar> It returns cloned copy of UCalendar instance with current locale etc - fastest way to get current UCalendar instance"

	^self now! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/3/2012 19:12'!
now
	"^<UCalendar> It returns cloned copy of UCalendar instance with current locale etc - fastest way to get current UCalendar instance"
	
	^ICUSystemLocale current calendarNowCloned	! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:36'!
nowAsDateAndTime
	"^<DateAndTime > Returns a DateAndTime instance via ICU subsystem"
	
	^ICUSystemLocale current calendarNowAsDateAndTime	! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:46'!
openCountryTimeZonesFor: countryString
	"^<UEnumerator>"

	^ UEnumerator address: (ICUInterfaceClass uCalOpenCountryTimeZonesFor: countryString)! !

!UCalendar class methodsFor: 'instance creation (ICU)' stamp: 'MartenFeldtmann 9/11/2012 21:36'!
openDefaultWithDefaultLocaleAndTimezone
	"^<UCalendar> Opens a default calendar for the default time zone - and the default locale

			UCalendar openDefaultWithDefaultLocaleAndTimezone asDateAndTime inspect
	
	"

	^self
		openWithZoneID: self getDefaultTimeZone
		locale: (ICUSystemLocale current locale)
		calType: UCAL_DEFAULT

! !

!UCalendar class methodsFor: 'instance creation (ICU)' stamp: 'MartenFeldtmann 9/4/2012 22:20'!
openDefaultWithLocale: localeString timezone: timezoneString
	"^<UCalendar> Opens a default calendar for a specific locale and time zone

			| anUErrorCode de answer |
			
			anUErrorCode := UErrorCode new.

			(UCalendar openWithZoneID: nil  locale: nil calType: 0 status: anUErrorCode) inspect
			
			
			| anUErrorCode de answer deCalendar |
			deCalendar := UCalendar openDefaultWithLocale: 'de_DE' timezone: (UCalendar dbAllCountryTimeZonesFor: 'DE') first.	
			deCalendar	
				year: 1901 month: 0 days: 1 hours: 0 minutes: 0 seconds: 0.
			answer := deCalendar inDaylightTime.
			deCalendar asDateAndTime inspect.
			deCalendar close.
			answer inspect
	
	"

	^self
		openWithZoneID: timezoneString
		locale: localeString
		calType: UCAL_DEFAULT

! !

!UCalendar class methodsFor: 'time zones (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:47'!
openTimeZones
	"^<UEnumerator>"

	^UEnumerator address: (ICUInterfaceClass uCalOpenTimeZones)
! !

!UCalendar class methodsFor: 'instance creation (ICU)' stamp: 'MartenFeldtmann 9/5/2012 20:47'!
openWithZoneID: timezoneString locale: localeString calType: calType
	"^<UCalendar>

		Usage: 
		
		| anInstance | 
		anInstance := UCalendar openWithZoneID: nil  locale: nil calType: 0.
		anInstance close
	"

	^ self address: (ICUInterfaceClass openWithZoneID: timezoneString locale: localeString calType: calType)! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:35'!
year: year day: dayOfYear hour: hour minute: minute second: second
	"^<UCalendar> Creates a new instance with the values. Because DateAndTime supports this method, all parameters
		have the same meanings as the DateAndTime method 
	"
	| aDateAndTime |
	aDateAndTime := DateAndTime
		year: year
		day: dayOfYear
		hour: hour
		minute: minute
		second: second.
	^ ICUInterfaceClass
				newFromDateAndTime: aDateAndTime
				locale: ICUSystemLocale current locale
				timezone: self getDefaultTimeZone! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:35'!
year: year day: dayOfYear hour: hour minute: minute second: second offset: aDuration
	"^<UCalendar> Creates a new instance with the values. Because DateAndTime supports this method, all parameters
		have the same meanings as the DateAndTime method 
	"
	
	| aDateAndTime |
	aDateAndTime := DateAndTime
		year: year
		day: dayOfYear
		hour: hour
		minute: minute
		second: second.
	^ ICUInterfaceClass
		newFromDateAndTime: aDateAndTime
		locale: ICUSystemLocale current locale
		timezone:
			'GMT'
				,
					(aDuration hours > 0
						ifTrue: [ '+' ]
						ifFalse: [ '-' ]) , aDuration hours abs printString! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:34'!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second
	"^<UCalendar> Creates a new instance with the values. Because DateAndTime supports this method, all parameters
		have the same meanings as the DateAndTime method (attribute: month)
	"
	| aDateAndTime |
	aDateAndTime := DateAndTime
		year: year
		month: month
		day: dayOfMonth
		hour: hour
		minute: minute
		second: second.
	^ICUInterfaceClass
				newFromDateAndTime: aDateAndTime
				locale: ICUSystemLocale current locale
				timezone: self getDefaultTimeZone! !

!UCalendar class methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 21:34'!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second offset: aDuration
	"^<UCalendar> Creates a new instance with the values. Because DateAndTime supports this method, all parameters
		have the same meanings as the DateAndTime method (attribute: month)
	"
	| aDateAndTime |
	
	aDateAndTime :=  DateAndTime year: year month: month day: dayOfMonth hour: hour minute: minute second: second.
	
	^ICUInterfaceClass newFromDateAndTime: aDateAndTime locale: ICUSystemLocale current locale  timezone: ('GMT'
				,
					(aDuration hours > 0
						ifTrue: [ '+' ]
						ifFalse: [ '-' ]) , aDuration hours abs printString)! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/7/2012 20:26'!
+ aDuration
	"
			UCalendar now + (Duration hours: 2)
	
	"

	^self clone addMilliseconds: aDuration asMilliSeconds! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/7/2012 20:24'!
- anUCalendarOrDuration
	"
	
	
	"

	^anUCalendarOrDuration subtractFromUCalendar: self! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/7/2012 20:24'!
< anUCalendar

	| newCalendar test |
	
	newCalendar := anUCalendar asUCalendar.
	test := self millis < newCalendar millis.
	(newCalendar == anUCalendar) not ifTrue:[ newCalendar close ].
	^test
! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/7/2012 20:18'!
= anUCalendar

	| newCalendar test |
	
	newCalendar := anUCalendar asUCalendar.
	test := newCalendar millis = self millis.
	(newCalendar == anUCalendar) not ifTrue:[ newCalendar close ].
	^test
! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/7/2012 20:24'!
> anUCalendar

	| newCalendar test |
	
	newCalendar := anUCalendar asUCalendar.
	test := self millis > newCalendar millis.
	(newCalendar == anUCalendar) not ifTrue:[ newCalendar close ].
	^test
! !

!UCalendar methodsFor: 'adding' stamp: 'MartenFeldtmann 9/6/2012 17:52'!
add: aUCalendarDateField with: value

	ICUInterfaceClass  uCalAdd: self field: aUCalendarDateField  value: value! !

!UCalendar methodsFor: 'adding' stamp: 'MartenFeldtmann 9/6/2012 17:53'!
addDays: days
	"adds the number of days days to the receiver"

	self
		add: UCAL_DATE
		with: days! !

!UCalendar methodsFor: 'adding' stamp: 'MartenFeldtmann 9/6/2012 17:53'!
addMilliseconds: aValue
	"adds the number of days days to the receiver"

	self
		add: UCAL_MILLISECOND
		with: aValue! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:08'!
ampm

	^self get: UCAL_AM_PM
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 16:22'!
applyPattern:  anUDateFormat pattern: patternString

	ICUInterfaceClass timeinfo: self dateFormat: anUDateFormat pattern: patternString asUtf16String! !

!UCalendar methodsFor: 'GreaseVASTCoreApp' stamp: 'MartenFeldtmann 9/6/2012 13:16'!
asDate
	"^<Date> returns an instance of class Date with my values"

	^Date newDay: self dayOfMonth monthIndex: self monthIndex year: self year! !

!UCalendar methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/9/2012 21:57'!
asDateAndTime
	"^<DateAndTime> returns an instance of class DateAndTime with my values"

	^DateAndTime
		year: self year
		"monthIndex = Smalltalk one based index"
		month: self monthIndex
		day: self dayOfMonth
		hour: self hours
		minute: self minutes
		second: self seconds
		nanoSecond: (self milliseconds * 1000000) 
		offset: self offset! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 20:58'!
asLocal

	| offsetDuration |
	
	offsetDuration := UCalendar now offset - self offset.
	
	^self clone
		addMilliseconds: offsetDuration asMilliSeconds  ;
		timeZone: self class getDefaultTimeZone ;
		yourself! !

!UCalendar methodsFor: 'GreaseVASTCoreApp' stamp: 'MartenFeldtmann 9/6/2012 13:16'!
asTime
	"^<Time>"
	
	^Time fromMilliseconds:  (self milliseconds + (self seconds * 1000) + (self minutes * 60000) + (self hours * 3600000))

! !

!UCalendar methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/9/2012 21:48'!
asUCalendar

	^self! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/9/2012 20:04'!
asUTC
	"^<UCalendar> returns a new cloned instance with timezone UTC"

	| newInstance |
	
	newInstance := self class openWithZoneID: 'GMT' locale: 'en_EN' calType: UCAL_DEFAULT.		
	newInstance 
		millis: self millis.
	
	^newInstance! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/11/2012 18:05'!
clear

	ICUInterfaceClass apiUCalClear: self asExternalFunctionParameter ! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 14:51'!
clone

	^UCalendar address: (ICUInterfaceClass uCalClone: self)! !

!UCalendar methodsFor: 'closing' stamp: 'MartenFeldtmann 9/5/2012 20:47'!
close

	ICUInterfaceClass uCalClose: self.! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:13'!
dayOfMonth

	^self get: UCAL_DATE! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:13'!
dayOfMonth: anInteger

	self
		set: UCAL_DATE
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:13'!
dayOfWeek

	^self get: UCAL_DAY_OF_WEEK! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/9/2012 14:28'!
dayOfWeekAbbreviation
	"^<Utf16String>"
	
	^ICUInterfaceClass dayOfWeekAbbreviation: self! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:08'!
dayOfWeekInMonth

	^self get: UCAL_DAY_OF_WEEK_IN_MONTH! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:09'!
dayOfWeekLocal

	^self get: UCAL_DOW_LOCAL
! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/9/2012 14:47'!
dayOfWeekName
	"^<Utf16String>"
	
	^ICUInterfaceClass dayOfWeekName: self! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:09'!
dayOfYear

	^self get: UCAL_DAY_OF_YEAR
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 21:18'!
dstOffset
	"^<Integer>	Field number indicating the daylight savings offset in milliseconds. "

	^self get: UCAL_DST_OFFSET! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:09'!
era
	"^<Integer>	"

	^self get: UCAL_ERA
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 07:36'!
fromDateAndTime: aDateAndTime

	
	ICUInterfaceClass 
	  fromDateAndTime: aDateAndTime calendar: self 

! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/5/2012 20:47'!
get: uciConstant

	^ICUInterfaceClass uCalGet: self selection: uciConstant! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:12'!
hour

	^self hour24! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:11'!
hour12

	^self get: UCAL_HOUR! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:12'!
hour24

	^self get: UCAL_HOUR_OF_DAY
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 20:24'!
hourOfDay

	^self get: UCAL_HOUR_OF_DAY
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 20:28'!
hourOfDay: anInteger

	^self set: UCAL_HOUR_OF_DAY with: anInteger
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:09'!
hours

	^self get: UCAL_HOUR_OF_DAY! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:09'!
hours: anInteger

	self
		set: UCAL_HOUR_OF_DAY
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 20:25'!
icuHour

	^self get: UCAL_HOUR! !

!UCalendar methodsFor: 'printing' stamp: 'MartenFeldtmann 9/8/2012 15:07'!
icuPrintOn: aStream

	self icuPrintOn: aStream format: ICUSystemLocale current enDateFormat! !

!UCalendar methodsFor: 'printing' stamp: 'MartenFeldtmann 9/8/2012 15:07'!
icuPrintOn: aStream format: aUDateFormat

	aStream nextPutAll: (
		aUDateFormat
			formatUCalendar: self 
			fieldPosition: nil)! !

!UCalendar methodsFor: 'printing' stamp: 'MartenFeldtmann 9/8/2012 15:07'!
icuPrintOn: aStream uLocale: aMSKLocale

	self
		icuPrintOn: aStream
		format: aMSKLocale dateFormat! !

!UCalendar methodsFor: 'testing' stamp: 'MartenFeldtmann 9/6/2012 22:29'!
inDaylightTime

	^(ICUInterfaceClass uCalInDaylightTime: self) ~= 0! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:14'!
isLeapYear

	^(Date leapYear: self year) == 1! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:10'!
julianDay

	^self get: UCAL_JULIAN_DAY! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/10/2012 11:03'!
meridianAbbreviation 
	"^<ByteString>"
	
	^ICUInterfaceClass meridianAbbreviation: self! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 20:27'!
milliSeconds

	^self get: UCAL_MILLISECOND! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 20:26'!
milliSeconds: anInteger

	self
		set: UCAL_MILLISECOND
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 14:45'!
millis

	^ICUInterfaceClass uCalGetMillis: self! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 14:45'!
millis: doubleValue

	^ICUInterfaceClass uCalSetMillis: self value: doubleValue! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:10'!
milliseconds

	^self get: UCAL_MILLISECOND! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:10'!
milliseconds: anInteger

	self
		set: UCAL_MILLISECOND
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:11'!
millisecondsInDay

	^self get: UCAL_MILLISECONDS_IN_DAY
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:14'!
minute

	^self minutes! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:11'!
minutes

	^self get: UCAL_MINUTE! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:11'!
minutes: anInteger

	self
		set: UCAL_MINUTE
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 20:19'!
month

	^(self get: UCAL_MONTH) + 1! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 20:21'!
month: anInteger

	self
		set: UCAL_MONTH
		with: (anInteger  -1)! !

!UCalendar methodsFor: 'GreaseVASTCoreApp' stamp: 'MartenFeldtmann 9/7/2012 20:20'!
monthIndex
	"^<Integer> Returns the index of the month (+1) to conform to Smalltalk standard"

	^self month ! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 20:20'!
monthIndex: anInteger

	self month: anInteger ! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/10/2012 11:23'!
monthName
	" <Symbol> Returns then abbreviation of the day in en  locale 
	
		UCalendar now monthName	
	"
	
	^ICUInterfaceClass monthName: self
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 14:29'!
now
	"^<Double> "
	
	^ICUInterfaceClass uCalGetNow ! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 21:20'!
offset
	"^<Duration> Answer a <Duration> representing the difference between the local time of the receiver and UTC."

	"
			| answer deCalendar |
			deCalendar := UCalendar openGregorianWithLocale: 'de_DE' timezone: (UCalendar dbAllCountryTimeZonesFor: 'DE') first.		
			answer := deCalendar offset.
			deCalendar close.
			answer inspect
		"

	^Duration milliSeconds: (
		self zoneOffset + (
			self inDaylightTime
				ifTrue: [ self dstOffset ]
				ifFalse: [ 0 ]))! !

!UCalendar methodsFor: 'printing' stamp: 'MartenFeldtmann 9/8/2012 15:07'!
printOn: aStream

	aStream nextPutAll: self printString! !

!UCalendar methodsFor: 'printing' stamp: 'MartenFeldtmann 9/9/2012 21:51'!
printString

	^self uPrintStringISO8601 asByteString 
	! !

!UCalendar methodsFor: 'adding' stamp: 'MartenFeldtmann 9/7/2012 20:56'!
roll: aUCalendarDateField with: value

	ICUInterfaceClass  uCalRoll: self field: aUCalendarDateField  value: value! !

!UCalendar methodsFor: 'adding' stamp: 'MartenFeldtmann 9/6/2012 17:53'!
rollDays: days
	"adds the number of days days to the receiver"

	self
		roll: UCAL_DATE
		with: days! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 13:14'!
second

	^self seconds! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:11'!
seconds

	^self get: UCAL_SECOND! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:11'!
seconds: anInteger

	self
		set: UCAL_SECOND
		with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:14'!
set: icuConstant with: integer

	ICUInterfaceClass uCalSet: self field: icuConstant fieldValue: integer

! !

!UCalendar methodsFor: 'helpers' stamp: 'MartenFeldtmann 9/10/2012 11:05'!
subtractFromUCalendar: anUCalendar
	"^<Duration>
	
		| now nowPlusTwo |
		
		now := UCalendar now.
		nowPlusTwo := now clone + (Duration hours: 2).
		(nowPlusTwo - now) inspect
	
	
	"

	^Duration milliSeconds: (anUCalendar millis - self millis)! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/7/2012 21:41'!
timeZone: aString

	| utf16String |
	utf16String := aString asUtf16String.
	
	ICUInterfaceClass uCalSetTimezone: self value: utf16String ! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/11/2012 07:21'!
timeZoneAbbreviation
	" <String> Returns then abbreviation of the timezone - not suitable in Pharo ...
	
		Usage UCalendar now timeZoneAbbreviation	
	"
	
	^ICUInterfaceClass timeZoneAbbreviation: self
! !

!UCalendar methodsFor: 'ANSI DateAndTime protocol' stamp: 'MartenFeldtmann 9/10/2012 11:17'!
timeZoneName
	" <String> Returns then abbreviation of the day in en  locale 
	
		UCalendar now timeZoneName	
	"
	
	^ICUInterfaceClass timeZoneName: self
! !

!UCalendar methodsFor: 'helpers' stamp: 'MartenFeldtmann 9/9/2012 18:12'!
timeinfo: anUCalendar dateFormat: anUDateFormat pattern: patternString
	"^<Utf16String> returns a textual representation of the values of the receiver regarding the patternString"
	
	| aString patternUtf16 |

	patternUtf16 := patternString asUtf16String.
	
	"... change the pattern in the cloned instance to get the name"
	self applyPattern:  anUDateFormat pattern: patternUtf16.
	
	"create the output ..."
	aString :=
		anUDateFormat
			formatUCalendar: anUCalendar 
			fieldPosition: nil.

	^aString asUtf16String! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:06'!
uDayOfWeekAbbreviation
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek abbreviation
	
		Example: UCalendar now uDayOfWeekAbbreviation	
	"	
	^ICUInterfaceClass currentLocaleDayOfWeekAbbreviation: self.
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:06'!
uDayOfWeekName
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek name
	
		Example: UCalendar now uDayOfWeekName	
	"	
	^ICUInterfaceClass currentLocaleDayOfWeekName: self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 17:46'!
uENPrintString
	"^<Utf16String> Returns a textual representation of the receiver defined by the pattern in the current ICU system locale	
		
			Usage: UCalendar now uENPrintString	
	"

	^ ICUSystemLocale current enDateFormat formatUCalendar: self fieldPosition: nil! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:11'!
uEnDayOfWeekAbbreviation
	"^<Utf16String> Returns a string in the english locale showing the dayOfWeek abbreviation
	
		UCalendar now uEnDayOfWeekAbbreviation
	
	"	
	^ICUInterfaceClass enLocaleDayOfWeekAbbreviation: self.
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:12'!
uEnDayOfWeekName
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek name
	
		Example: UCalendar now uEnDayOfWeekName	
	"	
	^ICUInterfaceClass enLocaleDayOfWeekName: self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:12'!
uEnMeridianAbbreviation
	"^<Utf16String> Returns the abbreviation of the meridian of anUCalendar using the current locale
	
		Example: UCalendar now uEnMeridianAbbreviation	
	"	
	^ICUInterfaceClass enMeridianAbbreviation:  self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:13'!
uEnMonthAbbreviation
	"^<Utf16String> Returns a string in the en locale showing the month abbreviation
	
		Example: UCalendar now uEnMonthAbbreviation	
	"	
	^ICUInterfaceClass enLocaleMonthAbbreviation: self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:09'!
uMeridianAbbreviation
	"^<Utf16String> Returns the abbreviation of the meridian of anUCalendar using the current locale
	
		Example: UCalendar now uMeridianAbbreviation	
	"	
	^ICUInterfaceClass currentLocaleMeridianAbbreviation:  self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/10/2012 18:42'!
uMonthAbbreviation
	"^<Utf16String> Returns a string in the current locale showing the month abbreviation
	
		Example: UCalendar now uMonthAbbreviation	
	"	
	^ICUInterfaceClass uMonthAbbreviation: self
	! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 16:35'!
uPrintString
	"^<Utf16String> Returns a textual representation of the receiver defined by the pattern in the current ICU system locale	
		
			Usage: UCalendar now uPrintString	
	"

	^ ICUSystemLocale current dateFormat formatUCalendar: self fieldPosition: nil! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/10/2012 18:44'!
uPrintStringISO8601
	"^<Utf16String> Returns a textual representation of the receiver defined by the pattern in the current ICU system locale	
		
			Usage: UCalendar now uPrintStringISO8601
	"
	
	^ICUSystemLocale current dateFormat formatUCalendar: self fieldPosition: nil.
! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 21:19'!
uPrintStringRfc1123
	"^<Utf16String> Returns a textual representation of the receiver defined by the pattern in the current ICU system locale	
		
			Usage: UCalendar now uPrintStringRfc1123
	"
	
	^ICUSystemLocale current enRfc1123DateFormat formatUCalendar: self fieldPosition: nil.
! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 21:19'!
uPrintStringRfc822
	"^<Utf16String> Returns a textual representation of the receiver defined by RFC822, Page 26	
		
			Usage: UCalendar now uPrintStringRfc822
	"
	
	^ICUSystemLocale current enRfc822DateFormat formatUCalendar: self fieldPosition: nil.
! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/9/2012 21:17'!
uPrintStringUTCRfc1123
	"^<Utf16String> Returns a textual representation of the receiver defined by the pattern in the current ICU system locale	
		
			Usage: UCalendar now uPrintStringUTCRfc1123 
	"
	
	^ICUSystemLocale current enUTCDateFormat formatUCalendar: self fieldPosition: nil.

! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/10/2012 11:18'!
uTimeZoneName
	" <String> Returns then abbreviation of the day in en  locale 
	
		UCalendar now timeZoneName	
	"
	
	^ICUInterfaceClass uTimeZoneName: self
! !

!UCalendar methodsFor: 'protocol ICU' stamp: 'MartenFeldtmann 9/10/2012 14:20'!
uTimeZoneName: anICUSystemLocale 
	" <Utf6String> Returns then abbreviation of the day using the default date format in anICUSystemLocale 
	
		usage: UCalendar now uTimeZoneName: ICUSystemLocale current 	
	"
	
	^ICUInterfaceClass uTimeZoneName: self systemLocale: anICUSystemLocale
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/5/2012 22:06'!
update

	self millis: self now
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:12'!
weekOfMonth

	^self get: UCAL_WEEK_OF_MONTH! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:12'!
weekOfYear

	^self get: UCAL_WEEK_OF_YEAR! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:12'!
year

	^self get: UCAL_YEAR! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 12:22'!
year: anInteger

	^self set: UCAL_YEAR with: anInteger! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 12:02'!
year: year month: monthIndex days: days hours: hours minutes: minutes seconds: seconds

	ICUInterfaceClass  uCalSetDateTime: self year: year monthIndex: monthIndex dayOfMonth: days hour: hours minute: minutes second: seconds! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/6/2012 11:12'!
yearWoy

	^self get: UCAL_YEAR_WOY
! !

!UCalendar methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 20:22'!
zoneOffset
	"^<Integer>  Field number indicating the raw offset from GMT in milliseconds.  "

	^self get: UCAL_ZONE_OFFSET! !

ICUGeneralObject subclass: #UCharsetDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UCharsetMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UCollator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UConverter
	instanceVariableNames: 'fromUnicodeTargetClass toUnicodeTargetClass'
	classVariableNames: 'DefaultConverter ISO885915Converter ISO88591Converter UTF8Converter'
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 20:43'!
aliasOf: sbString at: indexInteger
	"^<String> Returns a alias name for locale name <sbString> at index <zerobasedIndex>
	
		Usage:     UConverter aliasOf: 'utf8' at: 0	
	"
	
	^(OSStringZ address: (ICUInterfaceClass uCnvGetAlias: sbString at: indexInteger)) asString! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 17:05'!
allAliasesOf: sbString
	"^<OrderedCollection of: String> Returns all known aliases
	
			UConverter allAliasesOf: 'ibm-367'
		
	"

	| aCollection |

	aCollection := OrderedCollection new.
	0 to: ((self countAliasesOf: sbString) - 1) do: [ :eachIndex |
		aCollection add: (
			self
				aliasOf: sbString
				at: eachIndex) ].
	^aCollection! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/4/2012 22:41'!
clearDefaultConverters
	"UConverter clearDefaultConverters"

	DefaultConverter := nil.
	UTF8Converter := nil.
	ISO885915Converter := nil.
	ISO88591Converter := nil.
		
! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 20:44'!
compareName: aString against: anotherString

	^ICUInterfaceClass uCnvCompareNames: aString with: anotherString! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 20:44'!
countAliasesOf: sbString
	"^<Integer> Gives the number of aliases for a given converter or alias name. 
		Usage: UConverter countAliasesOf: 'utf8'	
	"

	^ICUInterfaceClass uCnvCountAliases: sbString ! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 16:00'!
countAvailable
	"^<Integer> Returns count of the number of available names"

	! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 16:00'!
countStandards
	"^<Integer> Gives the number of standards associated to converter names. 
		
	"

! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 16:00'!
dbAllCanonicalConverterNames
	"^<OrderedCollection of: DBString> getting all the recognized canonical converter names	
		UConverter dbAllCanonicalConverterNames	
		
	"

! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/11/2012 18:01'!
defaultConverter

	DefaultConverter isNil ifTrue:[ 
		DefaultConverter := UConverter openNamed: ICUInterfaceClass systemCodePageName.
		DefaultConverter
			fromUnicodeTargetClass:  ICUInterfaceClass singleByteStringClass;
			toUnicodeTargetClass: ICUInterfaceClass utf16StringClass.
	].
	^DefaultConverter! !

!UConverter class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/4/2012 22:35'!
initialize 
	
	Smalltalk addToStartUpList: self! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 17:26'!
isAlias: aString of: anotherString
	"^<Boolean>"

	^(self allAliasesOf: anotherString) includes: aString! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/11/2012 18:01'!
iso885915Converter
	"^<UConverter> Returns a converter instance able to convert between Latin-15 <-> Utf16String (Unicode)"
	
	ISO885915Converter isNil ifTrue:[
		ISO885915Converter := UConverter openNamed: 'iso8859-15'.
		ISO885915Converter
			fromUnicodeTargetClass:  ICUInterfaceClass singleByteStringClass ;
			toUnicodeTargetClass:  ICUInterfaceClass utf16StringClass .							
	].

	^ISO885915Converter! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/11/2012 18:01'!
iso88591Converter
	"^<UConverter> Returns a converter instance able to convert between Latin-1 <-> Utf16String (Unicode)"
	
	ISO88591Converter isNil ifTrue:[
		ISO88591Converter := UConverter openNamed: 'iso8859-1'.
		ISO88591Converter
			fromUnicodeTargetClass: ICUInterfaceClass singleByteStringClass ;
			toUnicodeTargetClass:  ICUInterfaceClass utf16StringClass						
	].
	^ISO88591Converter! !

!UConverter class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/5/2012 20:44'!
openNamed: converterNameStringOrNil
	"^<UConverter>
	
		converterNameStringOrNil is the name of the converter defined by a C string
	
	"

	^UConverter address: (ICUInterfaceClass uCnvOpen: converterNameStringOrNil)
! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/6/2012 14:21'!
releaseDefaultConverters
	"UConverter releaseDefaultConverters"

	"executing this with wrong pointer will break the stuff"
	"
		DefaultConverter notNil
		ifTrue: [
			DefaultConverter close.
			].
	UTF8Converter notNil
		ifTrue: [
			UTF8Converter close.
			].
	ISO885915Converter notNil
		ifTrue: [
			ISO885915Converter close.
			].
	ISO88591Converter notNil
		ifTrue: [
			ISO88591Converter close.
			]."
		
	self clearDefaultConverters
		
! !

!UConverter class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/4/2012 22:43'!
startUp: resuming
	"Clear the default instance if it was created for another platform."

	resuming
		ifTrue: [ self releaseDefaultConverters ]
		ifFalse: [ self clearDefaultConverters ]! !

!UConverter class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/4/2012 22:35'!
unload 

	Smalltalk removeFromStartUpList: self
			! !

!UConverter class methodsFor: 'services' stamp: 'MartenFeldtmann 9/11/2012 18:02'!
utf8Converter
	"^<UConverter> Returns a converter instance able to convert between utf-8 <-> Utf16String (Unicode)"

	UTF8Converter isNil ifTrue:[
		UTF8Converter := UConverter openNamed: 'UTF-8'.
		UTF8Converter
			fromUnicodeTargetClass: ICUInterfaceClass utf8StringClass ;
			toUnicodeTargetClass: ICUInterfaceClass utf16StringClass .
	].

	^UTF8Converter
! !

!UConverter methodsFor: 'closing' stamp: 'MartenFeldtmann 9/5/2012 20:48'!
close

	ICUInterfaceClass uCnvClose: self! !

!UConverter methodsFor: 'helpers' stamp: 'MartenFeldtmann 9/5/2012 20:48'!
converterName

	^ICUInterfaceClass uCnvGetName: self! !

!UConverter methodsFor: 'helpers' stamp: 'MartenFeldtmann 9/5/2012 20:48'!
displayNameInLocale: localeString
	"^<Utf16String> 
			Returns the display name of the converter based on the locale name localeString.
			If the locale contains no display name, the internal ASCII name will be filled in. 
	"
	
	^ICUInterfaceClass uCnvGetDisplayName: self string: localeString! !

!UConverter methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/4/2012 19:01'!
fromUnicode: dbString
	"^<String> Convert the Unicode string into a codepage string using an existing UConverter. "

	^self fromUtf16: dbString! !

!UConverter methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 12:46'!
fromUnicodeTargetClass
	^ fromUnicodeTargetClass! !

!UConverter methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 12:46'!
fromUnicodeTargetClass: anObject
	fromUnicodeTargetClass := anObject! !

!UConverter methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/5/2012 20:48'!
fromUtf16: dbString
	"^<String> Convert the Unicode string into a codepage string using an existing UConverter. "

	^ICUInterfaceClass uCnvFromChars: self string: dbString! !

!UConverter methodsFor: 'helpers' stamp: 'MartenFeldtmann 9/5/2012 20:48'!
getMaxCharSize

	^ICUInterfaceClass uCnvGetMaxCharSize: self! !

!UConverter methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/11/2012 23:08'!
toUnicode: byteStringOrUtf8String

	^ICUInterfaceClass uCnvToUChars: self string: byteStringOrUtf8String
	! !

!UConverter methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 12:46'!
toUnicodeTargetClass
	^ toUnicodeTargetClass! !

!UConverter methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 12:46'!
toUnicodeTargetClass: anObject
	toUnicodeTargetClass := anObject! !

ICUGeneralObject subclass: #UDateFormat
	instanceVariableNames: 'formatBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!UDateFormat class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 14:39'!
iso8601Style: localeString zone: timezone
	"^<UDateFormat> "

	| anUDateFormat |

	anUDateFormat := self 
							openTimeStyle: UDAT_IGNORE
							dateStyle: UDAT_IGNORE
							locale: localeString
							zoneName: timezone
							pattern: ISO8601DATEFORMAT.
	
	^anUDateFormat

! !

!UDateFormat class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/5/2012 20:49'!
openTimeStyle: timeStyle
	dateStyle: dateStyle
	locale: localeString
	zoneName: zoneString
	pattern: patternString
	"comment stating purpose of message"

	| localeSBString zoneDBString patternDBString |

	localeSBString := localeString ifNotNil: [ localeString asByteString  ].

	zoneDBString := zoneString ifNotNil: [ zoneString asUtf16String ].

	patternDBString := patternString ifNotNil: [ patternString asUtf16String ].
	
	^ UDateFormat
		address:
			(ICUInterfaceClass 
				uDatOpen: timeStyle
				dateStyle: dateStyle
				locale: localeSBString
				zone: zoneDBString
				pattern: patternDBString)! !

!UDateFormat class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 14:37'!
rfc1123Style: localeString zone: zoneName
	"^<UDateFormat> "

	| anUDateFormat |

	anUDateFormat := self 
							openTimeStyle: UDAT_IGNORE
							dateStyle: UDAT_IGNORE
							locale: localeString
							zoneName: zoneName
							pattern: RFC1123DATEFORMAT.
	
	^anUDateFormat

! !

!UDateFormat class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 14:41'!
rfc822Style: localeString zone: timezone
	"^<UDateFormat> "

	| anUDateFormat |

	anUDateFormat := self 
							openTimeStyle: UDAT_IGNORE
							dateStyle: UDAT_IGNORE
							locale: localeString
							zoneName: timezone
							pattern: RFC822DATEFORMAT.
	
	^anUDateFormat

! !

!UDateFormat methodsFor: 'copying' stamp: 'MartenFeldtmann 9/9/2012 14:27'!
clone


	^self class address: (ICUInterfaceClass uDatClone: self)! !

!UDateFormat methodsFor: 'closing' stamp: 'MartenFeldtmann 9/9/2012 13:47'!
close
	"comment stating purpose of message"

	ICUInterfaceClass  uDatClose: self! !

!UDateFormat methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 22:58'!
formatBlock
	^ formatBlock! !

!UDateFormat methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/4/2012 22:58'!
formatBlock: anObject
	formatBlock := anObject! !

!UDateFormat methodsFor: 'formating' stamp: 'MartenFeldtmann 9/9/2012 21:04'!
formatUCalendar: anUCalendar fieldPosition: anUFieldPosition
	"^<Utf16String>"
	
	^ICUInterfaceClass uDatFormat: self calendar: anUCalendar position: anUFieldPosition! !

ICUGeneralObject subclass: #UEnumerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!UEnumerator methodsFor: 'closing' stamp: 'MartenFeldtmann 9/5/2012 20:49'!
close

	ICUInterfaceClass apiUEnumClose: self asParameter ! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:50'!
collect: aBlock

	| nextItem result |

	result := OrderedCollection new.
	nextItem := self next.
	[ nextItem isEmpty ] whileFalse: [
		result add: (aBlock value: nextItem).
		nextItem := self next ].
	^result! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:54'!
collectAll

	^self collect: [:each | each ]! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:50'!
dbCollect: aBlock

	| nextItem result |

	result := OrderedCollection new.
	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		result add: (aBlock value: nextItem).
		nextItem := self uNext ].
	^result! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:29'!
dbDo: aBlock

	| nextItem |

	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		aBlock value: nextItem.
		nextItem := self uNext ]! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:29'!
dbSelect: aBlock

	| nextItem result |

	result := OrderedCollection new.
	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		(aBlock value: nextItem)
			ifTrue: [ result add: nextItem ].
		nextItem := self uNext ].
	^result! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/3/2012 21:30'!
do: aBlock

	| nextItem |

	nextItem := self next.
	[ nextItem isEmpty ] whileFalse: [
		aBlock value: nextItem.
		nextItem := self next ]! !

!UEnumerator methodsFor: 'enumerating' stamp: 'MartenFeldtmann 9/5/2012 20:49'!
next
	"^<String>"
	
	^ICUInterfaceClass uEnumNext: self resultLength: nil.

! !

!UEnumerator methodsFor: 'enumerating - unicode' stamp: 'MartenFeldtmann 9/3/2012 21:30'!
uCollect: aBlock

	| nextItem result |

	result := OrderedCollection new.
	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		result add: (aBlock value: nextItem).
		nextItem := self uNext ].
	^result! !

!UEnumerator methodsFor: 'enumerating - unicode' stamp: 'MartenFeldtmann 9/3/2012 21:31'!
uDo: aBlock

	| nextItem |

	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		aBlock value: nextItem.
		nextItem := self uNext ]! !

!UEnumerator methodsFor: 'enumerating - unicode' stamp: 'MartenFeldtmann 9/8/2012 15:00'!
uNext
	"^<DBString>"

	| buffer anOSInt32 anUErrorCode |

	buffer :=
		OSUInt8 address: (
			ICUInterfaceClass 
				apiUEnumUNext: self asParameter  
				resultLength: (anOSInt32 := OSInt32 new) asExternalFunctionParameter  
				errorCode: (anUErrorCode := UErrorCode new) asExternalFunctionParameter ). 			

	anUErrorCode failure ifTrue:[ ExICUError signal ].
	
	^buffer isNull
		ifTrue:[  Utf16String new ]
		ifFalse:[ Utf16String fromExternalAddress: buffer reference size:  (anOSInt32 at:0) ]
				! !

!UEnumerator methodsFor: 'enumerating - unicode' stamp: 'MartenFeldtmann 9/3/2012 21:31'!
uSelect: aBlock

	| nextItem result |

	result := OrderedCollection new.
	nextItem := self uNext.
	[ nextItem isEmpty ] whileFalse: [
		(aBlock value: nextItem)
			ifTrue: [ result add: nextItem ].
		nextItem := self uNext ].
	^result! !

ICUGeneralObject subclass: #UIDNA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UIDNAInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #ULocale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/11/2012 23:24'!
defaultLocaleName
	"^<ByteString>   Returns a single byte string containg the default locale name of this system (language and country)
	
		Usage: ULocale defaultLocaleName
	"
	
	^ICULibrariesInterface uLocGetDefault ! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 18:30'!
displayCountry: localeString displayLocale: displayLocaleString
	"^<Utf16String> returns the name of the country in the language defined by displayLocaleString
	
		Usage: ULocale displayCountry: 'de_DE' displayLocale: 'fr'
		
		the parameters MUST be single byte character
	
	"
	^ICULibrariesInterface uLocGetDisplayCountry: localeString displayLocale: displayLocaleString! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 18:25'!
displayLanguage: localeString displayLocale: displayLocaleString

	^ICULibrariesInterface uLocGetDisplayLanguage: localeString displayLocale: displayLocaleString! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 18:26'!
getCountryFor: localeID
	"^<String> Gets the ISO language code for the specified locale. 
	
		Usage: ULocale getCountryFor: ULocale defaultLocale		
	"

	^ICULibrariesInterface uLocGetCountry: localeID! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/7/2012 14:30'!
getISO3Country: localeString
	"comment stating purpose of message"

	^ ICUInterfaceClass uLocGetISO3Country: localeString! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/7/2012 14:30'!
getISO3Language: localeString
	"comment stating purpose of message"

	^ ICUInterfaceClass uLocGetISO3Language: localeString! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/7/2012 09:23'!
getISOCountries
	"
	"
	
	^ICULibrariesInterface uLocGetISOCountries ! !

!ULocale class methodsFor: 'gui gelpers' stamp: 'MartenFeldtmann 9/7/2012 09:30'!
getISOCountriesLangauge: langString country: countryString
	"^<Collection of: String>returns a list of ISO countries - ULocale getISOCountriesLangauge: 'fr' country: 'DE'   "

	|    sortedCollection displayLocale |

	sortedCollection := SortedCollection new.
	displayLocale := countryString,'_',langString.
	self getISOCountries do: [ :eachString |
		sortedCollection add: 	(self
				displayCountry: displayLocale
				displayLocale: eachString) , ' (' , langString , ')'.
		
	].

	^sortedCollection asOrderedCollection! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/7/2012 09:23'!
getISOLanguages
	"
	"
	
	^ICULibrariesInterface uLocGetISOLanguages ! !

!ULocale class methodsFor: 'services' stamp: 'MartenFeldtmann 9/5/2012 18:27'!
getLanguageFor: localeID
	"^<String> Gets the ISO language code for the specified locale. 
	
		Usage: ULocale getLanguageFor: ULocale defaultLocale
	"

	^ICULibrariesInterface uLocGetLanguage: localeID! !

ICUGeneralObject subclass: #UNumberFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #URegularExpression
	instanceVariableNames: 'patternString patternLength patternOSMemory patternOSMemorySize text textSize textOSMemory textOSMemorySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

ICUGeneralObject subclass: #UStringSearch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!UStringSearch class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 11:32'!
search: searchPatternString in: textString
	"^<UStringSearch>"
	^self
		search: searchPatternString
		in: textString
		locale: ICUSystemLocale current locale
		breakIterator: nil! !

!UStringSearch class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/10/2012 11:35'!
search: searchPatternString in: textString collator: anUCollator breakIterator: bIterator

	| addressInExternalMemory anUErrorCode unicodeSearchPattern utf16TextString |

	unicodeSearchPattern := searchPatternString asUtf16String.
	utf16TextString := textString asUtf16String.
		
	^self address:(
		ICUInterfaceClass 
			uSearchOpenFromCollator: unicodeSearchPattern 
			length: unicodeSearchPattern size
			text: utf16TextString 
			length utf16TextString size
			collator: anUCollator
			iterator: bIterator).
! !

ICUGeneralObject subclass: #UText
	instanceVariableNames: 'osMemory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-V2-System'!

!DateAndTime class methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 14:24'!
icuLocalYear: year
	month: month
	day: dayOfMonth
	hour: hour
	minute: minute
	second: second
	milliseconds: millseconds
	"^<DateAndTime> 
		I return a correctly initialized DateAndTime instance. The semantic is the same as with the 'normal' method - therefore
		month is between 1 .. and 12.
	"

	| deCalendar newInstance |

	deCalendar := ICUSystemLocale current calendarNowCloned.
	deCalendar
		year: year
		month: (month-1)
		days: dayOfMonth
		hours: hour
		minutes: minute
		seconds: second.
	deCalendar milliseconds: millseconds.
	newInstance := deCalendar asDateAndTime.
	deCalendar close.

	^newInstance! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 21:53'!
asUCalendar 

	| canonicalTimezoneName |

	canonicalTimezoneName := self icuTimezoneString.
	^ICULibrary interfaceClass newFromDateAndTime: self locale: nil timezone: canonicalTimezoneName



! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:14'!
icuPrintOn: aStream

	| meAsUCalendar |

	(meAsUCalendar := self asUCalendar) icuPrintOn: aStream.
	meAsUCalendar close! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:14'!
icuPrintOn: aStream format: aUDateFormat


	| meAsUCalendar |

	(meAsUCalendar := self asUCalendar)
		icuPrintOn: aStream
		format: aUDateFormat.
	meAsUCalendar close! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:15'!
icuPrintOn: aStream pattern: patternString locale: localeString zone: zoneString

	| meAsUCalendar |

	(meAsUCalendar := self asUCalendar)
		icuPrintOn: aStream
		pattern: patternString
		locale: localeString
		zone: zoneString.
	meAsUCalendar close! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:15'!
icuPrintOn: aStream uLocale: aMSKLocale

	| meAsUCalendar |

	(meAsUCalendar := self asUCalendar)
		icuPrintOn: aStream
		uLocale: aMSKLocale.
	meAsUCalendar close! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:15'!
icuPrintOn: aStream uLocale: aMSKLocale pattern: patternString

	| meAsUCalendar |

	(meAsUCalendar := self asUCalendar)
		icuPrintOn: aStream
		uLocale: aMSKLocale
		pattern: patternString.
	meAsUCalendar close! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 21:44'!
icuTimezoneString
	"^<String> Returns an instance of UCalendar
		Example: 	DateAndTime now asUCalendar	
	"

	"offset in ICU and DateAndTime are different !!"

	| writeStream |

	writeStream := WriteStream on: String new.
	writeStream
		nextPutAll: 'GMT';
		nextPut: (
			self offset hours < 0
				ifTrue: [ $- ]
				ifFalse: [ $+ ]).
	
	self offset hours abs
		printOn: writeStream base: 10 length: 2 padded: true.

	writeStream
		nextPut: $:.
		
	self offset minutes abs
		printOn: writeStream base: 10 length: 2 padded: true.

	^writeStream contents! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:15'!
subtractFromUCalendar: anUCalendar
	"^<Duration>
	
		| now nowPlusTwo |
		
		now := UCalendar now.
		nowPlusTwo := (now clone + (Duration hours: 2)) asDateAndTime.
		(nowPlusTwo - now) inspect
	
	
	"

	| newUCalendar result |

	newUCalendar := self asUCalendar.
	result := anUCalendar - newUCalendar.
	newUCalendar close.

	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 15:20'!
uDayOfWeekAbbreviation
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek abbreviation
	
		Example: DateAndTime now uDayOfWeekAbbreviation	
	"
	
	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := ICULibrary  interfaceClass currentLocaleDayOfWeekAbbreviation: meAsUCalendar.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 15:57'!
uDayOfWeekName
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek name
	
		Example: DateAndTime  now uDayOfWeekName	
	"	


	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := ICULibrary  interfaceClass currentLocaleDayOfWeekName: meAsUCalendar.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:12'!
uEnDayOfWeekAbbreviation
	"^<Utf16String> Returns a string in the english locale showing the dayOfWeek abbreviation
	
		DateAndTime now uEnDayOfWeekAbbreviation
	
	"
	
	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := ICULibrary  interfaceClass enLocaleDayOfWeekAbbreviation: meAsUCalendar.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:12'!
uEnDayOfWeekName
	"^<Utf16String> Returns a string in the current locale showing the dayOfWeek name
	
		Example: DateAndTime  now uEnDayOfWeekName	
	"	


	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := ICULibrary  interfaceClass enLocaleDayOfWeekName: meAsUCalendar.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:16'!
uEnMeridianAbbreviation

	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := meAsUCalendar uEnMeridianAbbreviation.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:14'!
uEnMonthAbbreviation
	"^<Utf16String> Returns a string in the en locale showing the month abbreviation
	
		Example: DateAndTime now uEnMonthAbbreviation	
	"	


	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := meAsUCalendar uEnMonthAbbreviation.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:15'!
uMeridianAbbreviation

	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := meAsUCalendar uMeridianAbbreviation.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 16:03'!
uMonthAbbreviation
	"^<Utf16String> Returns a string in the current locale showing the month abbreviation
	
		Example: DateAndTime now uMonthAbbreviation	
	"	


	| meAsUCalendar result |
	
	[	
		result := Utf16String emptyString.
		meAsUCalendar := self asUCalendar.
		result := meAsUCalendar uMonthAbbreviation.
	] ensure: [ meAsUCalendar ifNotNil: [meAsUCalendar close ]].
	
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:16'!
uMonthName

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uMonthName.
	meAsUCalendar close.
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:16'!
uPrintString

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uPrintString.
	meAsUCalendar close.
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:16'!
uTimeZoneAbbreviation

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uTimeZoneAbbreviation.
	meAsUCalendar close.
	^result! !

!DateAndTime methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/6/2012 16:16'!
uTimeZoneName

	| meAsUCalendar result |

	result := (meAsUCalendar := self asUCalendar) uTimeZoneName.
	meAsUCalendar close.
	^result! !

!ByteString methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 22:12'!
asUtf16String
	"^<Utf16String>"
	
	^UConverter iso885915Converter toUnicode: self! !

!ByteString methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/9/2012 22:11'!
asUtf8String
	"^<Utf8String>"
	
	^self asUtf16String asUtf8String ! !

Object subclass: #CharsetMatch
	instanceVariableNames: 'language name confidence'
	classVariableNames: ''
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-System'!

!CharsetMatch class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/9/2012 22:24'!
language: langString name: nameString confidence: anInteger

	^self new 
		language: langString ;
		name: nameString ;
		confidence: anInteger ;
		yourself ! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
confidence
	^ confidence! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
confidence: anObject
	confidence := anObject! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
language
	^ language! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
language: anObject
	language := anObject! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
name
	^ name! !

!CharsetMatch methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
name: anObject
	name := anObject! !

!CharsetMatch methodsFor: 'prinitng' stamp: 'MartenFeldtmann 9/9/2012 22:23'!
printOn: aStream

	aStream
		nextPutAll: 'CharsetMatch (language=[' ;
		nextPutAll: self language ;
		nextPutAll: '],  name = [' ;
		nextPutAll: self name ;
		nextPutAll: '], confidence = [' ;
		nextPutAll: self confidence asString ;
		nextPutAll: '])'! !

Object subclass: #ICUSystemLocale
	instanceVariableNames: 'nowTime locale timeZone offsetFromUTC collator dateFormat numberFormat utcDateFormat rfc822DateFormat rfc1123DateFormat localeLanguage localeTerritory enDateFormat'
	classVariableNames: 'Current English'
	poolDictionaries: 'ICUV2Constants'
	category: 'ICU-V2-System'!

!ICUSystemLocale class methodsFor: 'accessing default' stamp: 'MartenFeldtmann 9/10/2012 14:33'!
clearAll
	"ICUSystemLocale clearAll"

	Current := nil.
	English := nil.
	Transcript cr ; show: 'ICUSystemLocale(s) nulled'! !

!ICUSystemLocale class methodsFor: 'accessing default' stamp: 'MartenFeldtmann 9/11/2012 23:23'!
current

	Current isNil
		ifTrue: [
			Current :=
				self
					locale: ULocale defaultLocaleName
					timezone: UCalendar getDefaultTimeZone ].
	^Current! !

!ICUSystemLocale class methodsFor: 'accessing default' stamp: 'MartenFeldtmann 9/10/2012 15:07'!
english

	English isNil
		ifTrue: [
			English :=
				self
					locale: 'en_EN'
					timezone: UCalendar getDefaultTimeZone ].
	^English! !

!ICUSystemLocale class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/10/2012 14:33'!
initialize 
	
	Smalltalk addToStartUpList: self.! !

!ICUSystemLocale class methodsFor: 'accessing default' stamp: 'MartenFeldtmann 9/10/2012 15:07'!
locale: localeString timezone: timezone

	| newInstance |

	newInstance := self new.

	newInstance
		locale: localeString;
		timeZone: timezone;
		countryAbbreviation: localeString icuCountryCode;
		languageAbbreviation: localeString icuLanguageCode.
		
	newInstance
		offsetFromUTC: newInstance calendarNow offset;
		localeLanguage: (
			ULocale
				displayLanguage: localeString
				displayLocale: localeString);
		localeTerritory: (
			ULocale
				displayCountry: localeString
				displayLocale: localeString);
		collator: (self suitableCollators: localeString);
		dateFormat: (UDateFormat iso8601Style: localeString zone: timezone)  ;
		utcDateFormat: (UDateFormat iso8601Style: localeString zone: 'UTC');
		rfc822DateFormat: (UDateFormat rfc822Style: localeString zone: timezone) ;
		rfc1123DateFormat: (UDateFormat rfc1123Style: localeString zone: timezone).

	^newInstance! !

!ICUSystemLocale class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/10/2012 14:34'!
startUp: resuming
	"Clear the default instance if it was created for another platform."

	self clearAll.! !

!ICUSystemLocale class methodsFor: 'accessing default' stamp: 'MartenFeldtmann 9/3/2012 14:12'!
suitableCollators: localeString

	"localeString = 'de_DE'
		ifTrue: [ ^UCollator collatorForDIN500701 ].
	^UCollator openForLocale: localeString"! !

!ICUSystemLocale class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 9/10/2012 14:34'!
unload 

	self clearAll.
	Smalltalk removeFromStartUpList: self
			! !

!ICUSystemLocale methodsFor: 'time accessing' stamp: 'MartenFeldtmann 9/4/2012 21:26'!
calendarNow
	"^<UCalendar> Returns an instance UCalendar representing the actual time. The user should not change this instance"
	
	nowTime isNil ifTrue:[ ^nowTime := UCalendar openDefaultWithLocale: self locale timezone: self timeZone ].
	^nowTime update.! !

!ICUSystemLocale methodsFor: 'time accessing' stamp: 'MartenFeldtmann 9/6/2012 15:57'!
calendarNowAsDateAndTime
	"^<UCalendar> Returns a cloned instance UCalendar representing the actual time. This method should be called, if the 
		user wants to do further work with the returned instance
	"


	^[  self calendarNow asDateAndTime ] valueNoContextSwitch.! !

!ICUSystemLocale methodsFor: 'time accessing' stamp: 'MartenFeldtmann 9/6/2012 14:26'!
calendarNowCloned
	"^<UCalendar> Returns a cloned instance UCalendar representing the actual time. This method should be called, if the 
		user wants to do further work with the returned instance
	"

	^[ self calendarNow clone ] valueNoContextSwitch! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:28'!
collator
	^ collator! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:28'!
collator: anObject
	collator := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
countryAbbreviation
	^ countryAbbreviation! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
countryAbbreviation: anObject
	countryAbbreviation := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:28'!
dateFormat
	^ dateFormat! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:28'!
dateFormat: anObject
	dateFormat := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
languageAbbreviation
	^ languageAbbreviation! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
languageAbbreviation: anObject
	languageAbbreviation := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
locale
	^ locale! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
locale: anObject
	locale := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
localeLanguage
	^ localeLanguage! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
localeLanguage: anObject
	localeLanguage := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
localeTerritory
	^ localeTerritory! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
localeTerritory: anObject
	localeTerritory := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
offsetFromUTC
	^ offsetFromUTC! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:27'!
offsetFromUTC: anObject
	offsetFromUTC := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
rfc1123DateFormat
	^ rfc1123DateFormat! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
rfc1123DateFormat: anObject
	rfc1123DateFormat := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
rfc822DateFormat
	^ rfc822DateFormat! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
rfc822DateFormat: anObject
	rfc822DateFormat := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
timeZone
	^ timeZone! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 20:26'!
timeZone: anObject
	timeZone := anObject! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
utcDateFormat
	^ utcDateFormat! !

!ICUSystemLocale methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/10/2012 14:57'!
utcDateFormat: anObject
	utcDateFormat := anObject! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/5/2012 15:31'!
asExternalFunctionParameter 

	^self asNBExternalString! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 11:19'!
fromUnicodeCharacterNames
	"^<Utf16String>
	
		'LATIN CAPITAL LETTER M,LATIN SMALL LETTER A,LATIN SMALL LETTER R,LATIN SMALL LETTER T,LATIN SMALL LETTER E,LATIN SMALL LETTER N,SPACE,LATIN CAPITAL LETTER F,LATIN SMALL LETTER E,LATIN SMALL LETTER L,LATIN SMALL LETTER D,LATIN SMALL LETTER T,LATIN SMALL LETTER M,LATIN SMALL LETTER A,LATIN SMALL LETTER N,LATIN SMALL LETTER N' fromUnicodeCharacterNames
	
	
	"
	
	| listOfNames sizeOfString utf16String |
	
	listOfNames := self subStrings: ',' .
	sizeOfString := listOfNames size.
	utf16String := Utf16String new: sizeOfString.
	
	1 to: listOfNames size do: [ :eachIndex | 			
		| name |
		name := listOfNames at: eachIndex.
		utf16String at: eachIndex put: (Character uCharFromName:  name nameChoice: 0 )
	].
	
	^utf16String
	! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/5/2012 12:44'!
icuCountryCode
	"^<String> returns the country code of the receiver string, which represents a locale string
	
	
		'de_DE' icuCountryCode = 'DE'
	
	
	"
	
	^ICULibrary  interfaceClass uLocGetCountry: self! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/5/2012 12:47'!
icuLanguageCode
	"^<String> returns the language code of the receiver string, which represents a locale string
	
	
		'de_DE' icuLanguageCode = 'de'
	
	
	"
	
	^ICULibrary  interfaceClass uLocGetLanguage: self! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 11:31'!
toUnicodeCharacterNames
	"^<String> Returns a string containing a name for each character delimited by $,
	
		Usage: 	'Marten Feldtmann' toUnicodeCharacterNames
	"
	
	| writeStream initialDelimiterSet utf16String |
	
	writeStream := WriteStream on: String new.
	initialDelimiterSet := false.
	utf16String := UConverter defaultConverter toUnicode: self.
	
	1 to: utf16String size do: [ :anIndex | 	
		initialDelimiterSet ifTrue:[ writeStream nextPut: $, ].
		writeStream nextPutAll: ((utf16String at: anIndex) uCharName: 0).
		initialDelimiterSet := true.
	].
	
	^writeStream contents 
	! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/11/2012 12:01'!
toUtf8ByteArraySourceCodeString
	"^<String>
	
		Helper method to define unicode characters as a ByteArray Smalltalk source code
		
		Usage: '' toUtf8ByteArraySourceCodeString
	
			(UConverter defaultConverter toUnicode: 'Marten Feldtmann') asUtf8String
	"
	
	| writeStream initialDelimiterSet utf8String |
	
	writeStream := WriteStream on: String new.
	utf8String := (UConverter defaultConverter toUnicode: self) asUtf8String.

	writeStream
		nextPut: $" ;
		nextPutAll: (UConverter defaultConverter toUnicode: self) toUnicodeCharacterNames  ;
		nextPutAll: ' fromUnicodeCharacternames "';
		cr.
	
	writeStream
		nextPutAll: ' iVar := #['.
			
	utf8String do: [ :eachCharacter | 
		writeStream 
			nextPutAll: '16r'.
		eachCharacter uCodePoint printOn: writeStream base: 16  length: 2  padded: true.
			
		writeStream space
	].

	writeStream
		nextPutAll: '] asUtf16StringFromUtf8.'.

	^writeStream contents! !

!String methodsFor: '*ICU-V2-System' stamp: 'MartenFeldtmann 9/5/2012 15:20'!
ucnvCompareName: anotherString

	^ICULibrary interfaceClass uCnvCompareNames: self with: anotherString! !
ICUSystemLocale initialize!
UConverter initialize!
